; 
; uncomment for library (and ' end ' at bottom
comment ^
      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive


include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\macros\macros.asm
include \masm32\include\gdi32.inc

comment ^

Splash       proto :dword,:dword,:dword
SplashProc   proto :dword,:dword,:dword,:dword
sTopXY       proto :dword,:dword
MakeRegion   proto :dword,:dword,:dword
WinRegion    proto :dword,:dword

; |||||||||||||||||||||||||||| SPASH |||||||||||||||||||||||||||||

;         Splash proc hInstance:dword, resource:dword, millisecs:dword
; Returns eax = handle to Splash window
; 0 millisecs = Use handle to destroy window after WM_CREATE

; This uses a bitmap as the splash screen. The bmp is converted to a custom window shape
; using the 'MakeRegion' routine by MOB. The size of the splash is the same as the bitmap.
; If the timeout value, msec is zero, you should use DestroyWindow,hSplash at the end of WM_CREATE.
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

.code
ALIGN 4
Splash proc hinst:dword,resc:dword,msec:dword
local spl    :WNDCLASSEX
local xwide  :dword
local yhigh  :dword
local hsplash:dword
local hBmpb  :dword
local bm     :BITMAP

       szText szSplashName,"Splash_Class"

       mov spl.cbSize,sizeof WNDCLASSEX          ; create class
       mov spl.style,CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS 
       mov spl.lpfnWndProc,offset SplashProc     ; point to splash proc
       mov spl.cbClsExtra,0
       mov spl.cbWndExtra,0
       m2m spl.hInstance,hinst
       m2m spl.hbrBackground,0
       mov spl.lpszMenuName,0
       mov spl.lpszClassName,offset szSplashName
       mov spl.hIcon,0
       mov spl.hCursor,0
       mov spl.hIconSm,0

       invoke RegisterClassEx,addr spl

       invoke LoadBitmap,hinst,resc              ; bitmap from resource
       mov hBmpb,eax                             
       invoke GetObject,hBmpb,sizeof bm,addr bm  ; get bmp dimentions

       invoke GetSystemMetrics,SM_CXSCREEN
       invoke sTopXY,bm.bmWidth,eax
       mov xwide,eax
       invoke GetSystemMetrics,SM_CYSCREEN
       invoke sTopXY,bm.bmHeight,eax
       mov yhigh,eax                             ; create the splash window
       invoke CreateWindowEx,WS_EX_TOPMOST,ADDR szSplashName,0,WS_POPUP,
                            xwide,yhigh,bm.bmWidth,bm.bmHeight,0,0,hinst,0
       mov hsplash,eax                           ; same size as bmp

       invoke WinRegion,hsplash,hBmpb            ; create shape

     .if msec != 0
       invoke SetTimer,hsplash,1000,msec,0       ; timeout value
     .endif

       invoke SetWindowLong,hsplash,GWL_USERDATA,hBmpb    ; send bitmap handle to SplashProc
       invoke ShowWindow,hsplash,SW_SHOWNORMAL
       invoke UpdateWindow,hsplash
       mov eax,hsplash                           ; return splash window handle
     ret
Splash endp

; ||||||||||||||||||||||||||||| END SPLASH |||||||||||||||||||||||||||||

; center splash
ALIGN 4
sTopXY proc swDim:DWORD, ssDim:DWORD
    shr ssDim, 1
    shr swDim, 1 
    mov eax, swDim 
    sub ssDim, eax   
    mov eax,ssDim
    ret
sTopXY endp


; ||||||||||||||||||||||||||||||| SplashProc |||||||||||||||||||||||||||
ALIGN 4
SplashProc proc uses edi ecx hWin:dword,uMsg:dword,wParam:dword,lParam:dword
local hDC   :dword
local Ps    :PAINTSTRUCT
local hfont :HFONT     
local srect :RECT
local hBmpb :dword
local bcol  :dword
local slf   :LOGFONT
local hMemDC:dword

   .if uMsg == WM_TIMER
       invoke KillTimer,hWin,1000                     
       invoke DestroyWindow,hWin                      ; destroy splash window on
                                                      ; first timer message
   .elseif uMsg == WM_DESTROY
       invoke DeleteObject,hBmpb
       invoke DeleteObject,hfont

   .elseif uMsg == WM_PAINT
       invoke GetWindowLong,hWin,GWL_USERDATA         ; get bitmap handle
       mov hBmpb,eax  
       invoke GetClientRect,hWin,addr srect           ; destination rectagle
       invoke BeginPaint,hWin,addr Ps                 ; gets the device context
       mov hDC,eax                                    ; into memory hdc
       invoke CreateCompatibleDC,NULL                 ; gets a compatable source
       mov hMemDC,eax                                 ; dc into memory hMemDC
       invoke SelectObject,hMemDC,hBmpb               ; get image into source
       invoke BitBlt,hDC,0,0,srect.right,             ; block mov data to destination
                                       srect.bottom,hMemDC,0,0,SRCCOPY
       invoke DeleteDC,hMemDC                         ; delete the device
       invoke EndPaint,hWin,addr Ps                   ; end of paint structure (ps)

   .endif

        invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

SplashProc endp

;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||


ALIGN 4
WinRegion proc hWin:dword,hBmpx:dword
local hdc:dword
local hMemDC:dword
local rc:RECT

        invoke GetWindowDC,hWin
        mov hdc,eax                         ; the area to be painted
        invoke CreateCompatibleDC,NULL      ; make a same type area
        mov hMemDC,eax                      ; for custom window shape
        invoke SelectObject,hMemDC,hBmpx    ; put the image on it    
        invoke GetClientRect,hWin,addr rc   ; the rectangle of win area
        invoke MakeRegion,hMemDC,rc.right,rc.bottom ; the code by MOB               
        invoke SetWindowRgn,hWin,eax,TRUE   ; sets the drawing area                        
        invoke ReleaseDC,hWin,hdc           ; release the 
        invoke DeleteDC,hMemDC              ; devices

   ret
WinRegion endp

ALIGN 4
; |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
MakeRegion PROC USES ESI EDI EBX _xdc:HDC, _wdt:DWORD, _hgt:DWORD
; custom window shape
; This routine by MOB
; the pixel at location 0,0 of the bitmap is taken as the transparant colour

LOCAL flag: DWORD
LOCAL frun: DWORD
LOCAL d_dc: DWORD
LOCAL f_dc: DWORD
LOCAL oldx: DWORD
LOCAL tcol: DWORD                

        mov     flag,FALSE
        mov     frun,TRUE
        mov     oldx,0
        xor     edi,edi
        xor     esi,esi

        invoke  GetPixel,_xdc,0,0
        mov     tcol,eax              
        
_xloop: invoke  GetPixel,_xdc,edi,esi

        cmp     eax,tcol
        jz      _letsgo

        cmp     edi,_wdt
        jnz     _foundone
        
 _letsgo:  
        cmp     flag,TRUE           
        jnz     _nextone
        
        mov     flag,FALSE        
        mov     eax,esi
        inc     eax
        invoke  CreateRectRgn,ebx,esi,edi,eax
        mov     d_dc,eax

        cmp     frun,TRUE       
        jnz     _nofrun
        mov     frun,FALSE
        push    d_dc
        pop     f_dc
        jmp     _nextone

_nofrun:
        invoke  CombineRgn,f_dc,f_dc,d_dc,RGN_OR
        invoke  DeleteObject,d_dc          
        jmp     _nextone
          
_foundone:
        cmp     flag,FALSE
        jnz     _nextone
        mov     flag,TRUE
        mov     ebx,edi

_nextone:
        inc     edi
        cmp     edi,_wdt
        jbe     _xloop
        
        xor     edi,edi       
        inc     esi
        cmp     esi,_hgt
        jb      _xloop
        
_exit:  mov     eax,f_dc      
        ret

MakeRegion ENDP



;end

;